"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ClinicalReportRD(ProtocolElement):
    """
    A clinical report for the rare disease program. This holds the list of
    reported variants by a GMC together with all     the relevant
    information that identify the case and how these conclusions were
    reached.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "genomicInterpretation",
        "interpretationRequestId",
        "interpretationRequestVersion",
        "referenceDatabasesVersions",
        "reportingDate",
        "softwareVersions",
        "user",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "additionalAnalysisPanels": reports_5_0_0.AdditionalAnalysisPanel,
            "variants": reports_5_0_0.ReportedVariant,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.AdditionalAnalysisPanel": reports_5_0_0.AdditionalAnalysisPanel,
            "org.gel.models.report.avro.ReportedVariant": reports_5_0_0.ReportedVariant,
            "org.gel.models.report.avro.ClinicalReportRD": reports_5_0_0.ClinicalReportRD,
        }

    __slots__ = [
        "genomicInterpretation",
        "interpretationRequestId",
        "interpretationRequestVersion",
        "referenceDatabasesVersions",
        "reportingDate",
        "softwareVersions",
        "user",
        "additionalAnalysisPanels",
        "references",
        "variants",
    ]

    def __init__(
        self,
        genomicInterpretation,
        interpretationRequestId,
        interpretationRequestVersion,
        referenceDatabasesVersions,
        reportingDate,
        softwareVersions,
        user,
        additionalAnalysisPanels=None,
        references=None,
        variants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.ClinicalReportRD model.

        :param genomicInterpretation:
            Summary of the interpretation, this should reflect the positive
            conclusions of this interpretation
        :type genomicInterpretation: str
        :param interpretationRequestId:
            This is the interpretation request identifier (i.e.: first number in
            XXX-123-1)
        :type interpretationRequestId: str
        :param interpretationRequestVersion:
            This is the version of the interpretation request identifier (i.e.:
            second number in XXX-123-2)
        :type interpretationRequestVersion: int
        :param referenceDatabasesVersions:
            This map contains the versions of the different databases used in the
            process, being the database names the         keys and the
            versions the values.
        :type referenceDatabasesVersions: dict[str, str]
        :param reportingDate:
            Date of this report in format YYYY-MM-DD
        :type reportingDate: str
        :param softwareVersions:
            This map contains the versions of the different software systems used
            in the process, being the software         names the keys
            and the versions the values.
        :type softwareVersions: dict[str, str]
        :param user:
            Author of this report
        :type user: str
        :param additionalAnalysisPanels:
            The list of panels analysed to generate this report
        :type additionalAnalysisPanels: None | list[AdditionalAnalysisPanel]
        :param references:
            Supporting evidence (pubmed identifiers)
        :type references: None | list[str]
        :param variants:
            List of reported variants
        :type variants: None | list[ReportedVariant]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
